/*
*  Super Nudge by lacosox.org
* =============================
*
*Permite enviar multiples mensajes de atención, nudges, según la 
* cantidad que sea especificada en el argumento.
*
*
* Modo de uso:
*============
*
* Desde la venta de chat ejecutar el comando :
*
* /supernudge (Cantidad de nudges a enviar)
*
* Ejemplo :  /supernudge 45   -> Serán enviados 45 mensajes de atención.
*
* 
* Versión 1.0 
* 99% en inglés
* by Danilo Lacoste
* danilo@lacosox.org
* www.lacosox.org
*
* 23 Obtubre 2008
*/

//Necesarias para usar la funcion _() 
#define GETTEXT_PACKAGE "gtk20"
#include <glib/gi18n-lib.h>

//==================================

#define PURPLE_PLUGINS

#include <glib.h>
#include <stdio.h>  
#include <stdlib.h>  
#include <string.h>  
#include <ctype.h> 

#include "notify.h"
#include "plugin.h"
#include "version.h"
#include "cmds.h"
#include "debug.h"


#define MSN_NUDGE 0
#define SUPERNUDGE_ID "core-SuperNudge"
#define SUPERNUDGE_NAME "Super Nudge"
#define SUPERNUDGE_VERSION "1.0"
#define SUPERNUDGE_CREATOR "Danilo Lacoste <danilo@lacosox.org>"
#define LACOSOX_WEBSITE "http://www.lacosox.org"
#define SUPERNUDGE_DETAIL "Create the '/supernudge' command, to send new nudge orders"
#define SUPERNUDGE_DETAIL2 "Super Nudge Plugin for pidgin by Lacosox.org"
int isNumeric(const char *val)  
{  
   int i = 0, s = 0;  
   
   for(i = 0; i < strlen(val); i++)  
     if(isdigit(val[i]) == 0)  
       s = -1;  
   
   return s;  
}

static PurpleCmdRet
msn_cmd_supernudge(PurpleConversation *conv, const gchar *cmd, gchar **args, gchar **error, void *data)
{
	int total=0;
	int counter=0;
	
        PurpleAccount *account = purple_conversation_get_account(conv);
        PurpleConnection *gc = purple_account_get_connection(account);
        const gchar *username;

        username = purple_conversation_get_name(conv);

	if(isNumeric(args[0]) != 0)
		{ 
		 purple_debug_info(SUPERNUDGE_ID,"The argument %s is not a number\n",args[0]);
		}
 	else
 		{
		total= atoi(args[0]);
 		purple_debug_info(SUPERNUDGE_ID,
 		"OK, The argument %s is a number\n To be send %s messages attentions",args[0],args[0]);
		for(counter=0; counter < total; counter++)
			purple_prpl_send_attention(gc, username, MSN_NUDGE);			
 		}

        return PURPLE_CMD_RET_OK;
}


static gboolean plugin_load(PurplePlugin *plugin)
{

        purple_cmd_register("supernudge", "w", PURPLE_CMD_P_PRPL,
                          PURPLE_CMD_FLAG_IM | PURPLE_CMD_FLAG_PRPL_ONLY,
                         "prpl-msn", msn_cmd_supernudge,
                          _("supernudge: evolution of nudge command, a user to get their attention.\n usage: /supernudge (a Number) \n to be send (a Number) atentions messages.\n supernudge is by www.lacosox.org"), NULL);

	return TRUE;
}


static PurplePluginInfo info = {
    PURPLE_PLUGIN_MAGIC,
    PURPLE_MAJOR_VERSION,
    PURPLE_MINOR_VERSION,
    PURPLE_PLUGIN_STANDARD,
    NULL,
    0,
    NULL,
    PURPLE_PRIORITY_DEFAULT,

    SUPERNUDGE_ID,
    SUPERNUDGE_NAME,
    SUPERNUDGE_VERSION,

    SUPERNUDGE_DETAIL,          
    SUPERNUDGE_DETAIL2,          
    SUPERNUDGE_CREATOR,                          
    LACOSOX_WEBSITE,     
    
    plugin_load,                   
    NULL,                          
    NULL,                          
                                   
    NULL,                          
    NULL,                          
    NULL,                        
    NULL,                   
    NULL,                          
    NULL,                          
    NULL,                          
    NULL                           
};                               
    
static void                        
init_plugin(PurplePlugin *plugin)
{                                  
}

PURPLE_INIT_PLUGIN(SuperNudge, init_plugin, info)

